<?php
/**
 * @version SOFORT Gateway - $Date: 2012-09-06 13:49:09 +0200 (Thu, 06 Sep 2012) $
 * @author SOFORT AG (integration@sofort.com)
 * @link http://www.sofort.com/
 *
 * Copyright (c) 2012 SOFORT AG
 *
 * $Id: sofortOrderShopTools.php 5326 2012-09-06 11:49:09Z boehm $
 *
 */


/**
 * get language file
 * @param  string $lng
 * @param  string $paymentMethod
 * @return string
 */
function shopGetLanguageFile($lng, $paymentMethod){
	switch($paymentMethod){
		case 'LS':		$fileName = 'ls';	   break;
		case 'SL':		$fileName = 'sl';	   break;
		case 'SR':		$fileName = 'sr';	   break;
		case 'SU':		$fileName = 'su';	   break;
		case 'SV':		$fileName = 'sv';	   break;
		case 'general': $fileName = 'general'; break;
	}
	return DIR_FS_CATALOG.'includes/languages/'.$lng.'/modules/payment/sofort_'.strtolower($fileName).'.php';
}


/**
 * get link to packing slip
 * @return string
 */
function shopGetPackingslipLink(){
	return FILENAME_ORDERS_PACKINGSLIP;
}


/**
 * get link to invoice
 * @return string
 */
function shopGetInvoiceLink(){
	return FILENAME_ORDERS_INVOICE;
}


/**
 * get packing slip text
 * @return string
 */
function shopGetPackingslipText(){
	return IMAGE_ORDERS_PACKINGSLIP;
}


/**
 * get "back" text
 * @return string
 */
function shopGetBackText(){
	return IMAGE_BACK;
}


/**
 * get "invoice" text
 * @return string
 */
function shopGetInvoiceText(){
	return IMAGE_ORDERS_INVOICE;
}


/**
 * get logo for specified sofort-paymentMethod
 * @param  string $paymentMethodShort
 * @return string
 */
function shopGetLogo($paymentMethodShort){
	$str = constant('MODULE_PAYMENT_SOFORT_'.$paymentMethodShort.'_TEXT_TITLE');
	return $logo = substr($str, strrpos($str, '<img'));
}


/**
 * get link to top part of orders.php
 * @return string
 */
function shopGetTop(){
	return DIR_FS_CATALOG_MODULES.'payment/sofort/ressources/scripts/ordersTop.php';
}


/**
 * get link to bottom part of orders.php
 * @return string
 */
function shopGetBottom(){
	return DIR_FS_CATALOG_MODULES.'payment/sofort/ressources/scripts/ordersBottom.php';
}


/**
 * get tooltip image
 * @return string
 */
function shopGetTooltipImage(){
	return DIR_WS_CATALOG.DIR_WS_MODULES.'payment/sofort/ressources/images/ilink.gif';
}


/**
 * get icon path
 * @return string
 */
function shopGetIconPath(){
	return DIR_WS_CATALOG.DIR_WS_MODULES.'payment/sofort/ressources/images/';
}


/**
 * get config key
 * @return string
 */
function shopGetConfigKey(){
	return MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY;
}


/**
 * only return result if it contains exactly 1 row
 * @param string $query (escaped!)
 * @return boolean
 */
function shopDbCheckAndFetchOne($query){
	$result = mysql_query($query);
	if (mysql_num_rows($result)==0 || mysql_num_rows($result)>=2) {
		return false;
	} else {
		return mysql_fetch_array($result);
	}
}


/**
 * handle and submit status / comment change via orderdetailpage
 * @param int	 $oID
 * @param object $order
 * @param string $status
 * @param string $comments
 * @param string $notifyCustomer
 * @param string $notifyWithComments
 */
function shopSofortComment($oID, $order, $status, $comments, $notifyCustomer, $notifyWithComments){
	global $messageStack;
	
	$status = shopDbPrepareInput($status);
	$comments = shopDbPrepareInput($comments);
	$order_updated = false;
	$check_status = shopDbQuery("	SELECT	customers_name, customers_email_address, orders_status, date_purchased
									FROM	".shopDbInput(TABLE_ORDERS)."
									WHERE	orders_id = '".(int)$oID."'");
	
	if (($check_status->fields['orders_status'] != $status) || zen_not_null($comments)) {
		shopDbQuery("	UPDATE	".shopDbInput(TABLE_ORDERS)."
						SET		orders_status = '".shopDbInput($status)."', last_modified = now()
						WHERE	orders_id = '".(int)$oID."'");
		$customer_notified = '0';
		
		if (isset($notifyCustomer) && ($notifyCustomer == '1')) {
			$notify_comments = '';
			
			if (isset($notifyWithComments) && ($notifyWithComments == 'on') && zen_not_null($comments)) {
				$notify_comments = EMAIL_TEXT_COMMENTS_UPDATE.$comments."\n\n";
			}
			
			//send emails
			$message =	EMAIL_TEXT_ORDER_NUMBER.' '.$oID."\n\n".
						EMAIL_TEXT_INVOICE_URL.' '.shopCatalogHrefLink(FILENAME_CATALOG_ACCOUNT_HISTORY_INFO, 'order_id='.$oID, 'SSL')."\n\n".
						EMAIL_TEXT_DATE_ORDERED.' '.shopDateLong($check_status->fields['date_purchased'])."\n\n".
						strip_tags($notify_comments).
						EMAIL_TEXT_STATUS_UPDATED.sprintf(EMAIL_TEXT_STATUS_LABEL, $orders_status_array[$status]).
						EMAIL_TEXT_STATUS_PLEASE_REPLY;
			
			$html_msg['EMAIL_CUSTOMERS_NAME']			= $check_status->fields['customers_name'];
			$html_msg['EMAIL_TEXT_ORDER_NUMBER']		= EMAIL_TEXT_ORDER_NUMBER.' '.$oID;
			$html_msg['EMAIL_TEXT_INVOICE_URL']			= '<a href="'.shopCatalogHrefLink(FILENAME_CATALOG_ACCOUNT_HISTORY_INFO, 'order_id='.$oID, 'SSL') .'">'.str_replace(':','',EMAIL_TEXT_INVOICE_URL).'</a>';
			$html_msg['EMAIL_TEXT_DATE_ORDERED']		= EMAIL_TEXT_DATE_ORDERED.' '.shopDateLong($check_status->fields['date_purchased']);
			$html_msg['EMAIL_TEXT_STATUS_COMMENTS']		= nl2br($notify_comments);
			$html_msg['EMAIL_TEXT_STATUS_UPDATED']		= str_replace('\n','', EMAIL_TEXT_STATUS_UPDATED);
			$html_msg['EMAIL_TEXT_STATUS_LABEL']		= str_replace('\n','', sprintf(EMAIL_TEXT_STATUS_LABEL, $orders_status_array[$status]));
			$html_msg['EMAIL_TEXT_NEW_STATUS']			= $orders_status_array[$status];
			$html_msg['EMAIL_TEXT_STATUS_PLEASE_REPLY']	= str_replace('\n','', EMAIL_TEXT_STATUS_PLEASE_REPLY);
			
			shopDbMail($check_status->fields['customers_name'], $check_status->fields['customers_email_address'], EMAIL_TEXT_SUBJECT.' #'.$oID, $message, STORE_NAME, EMAIL_FROM, $html_msg, 'order_status');
			$customer_notified = '1';
	
			//send extra emails
			if (SEND_EXTRA_ORDERS_STATUS_ADMIN_EMAILS_TO_STATUS == '1' and SEND_EXTRA_ORDERS_STATUS_ADMIN_EMAILS_TO != '') {
				shopDbMail('', SEND_EXTRA_ORDERS_STATUS_ADMIN_EMAILS_TO, SEND_EXTRA_ORDERS_STATUS_ADMIN_EMAILS_TO_SUBJECT.' '.EMAIL_TEXT_SUBJECT.' #'.$oID, $message, STORE_NAME, EMAIL_FROM, $html_msg, 'order_status_extra');
			}
		} elseif (isset($notifyCustomer) && ($notifyCustomer == '-1')) {
			// hide comment
			$customer_notified = '-1';
		}
		
		shopDbQuery("	INSERT INTO ".shopDbInput(TABLE_ORDERS_STATUS_HISTORY)."
							(orders_id, orders_status_id, date_added, customer_notified, comments)
						VALUES
							('".(int)$oID."', '".shopDbInput($status)."', now(), '".shopDbInput($customer_notified)."', '".shopDbInput($comments)."')");
		$order_updated = true;
	}
	
	$order = new order((int)$oID);
	
	if ($order_updated == true) {
		if ($status == DOWNLOADS_ORDERS_STATUS_UPDATED_VALUE) {
			// adjust download_maxdays based on current date
			$zc_max_days = zen_date_diff($check_status->fields['date_purchased'], date('Y-m-d H:i:s', time())) + DOWNLOAD_MAX_DAYS;
			$update_downloads_query = "	UPDATE	".shopDbInput(TABLE_ORDERS_PRODUCTS_DOWNLOAD)."
										SET		download_maxdays='".shopDbInput($zc_max_days)."', download_count='".shopDbInput(DOWNLOAD_MAX_COUNT)."'
										WHERE	orders_id='".(int)$oID."'";
			shopDbQuery($update_downloads_query);
		}
		
		$messageStack->add_session(SUCCESS_ORDER_UPDATED, 'success');
	} else {
		$messageStack->add_session(WARNING_ORDER_NOT_UPDATED, 'warning');
	}
	
	return;
}


///////////////////////////////////////////////////////
// Following functions only wrap shop-core-functions //
// ------------------------------------------------- //
// Hinweis: in den ..Db..-Funktionen wurde teilweise //
//			bewusst auf die mysql_befehle zurückge-  //
//			griffen, da das nutzen des DB-Objekts zu //
//			viele Änderungen notwendig gemacht hätte //
///////////////////////////////////////////////////////


function shopGetTaxRate($class_id){
	return zen_get_tax_rate($class_id);
}


/**
 * @param string $query (escaped!)
 */
function shopDbQuery($query){
	return mysql_query($query);
}


function shopDbPerform($table, $data, $action = 'insert', $parameters = '', $link = 'db_link'){
	return zen_db_perform($table, $data, $action, $parameters, $link);
}


/**
 * @param string $query (escaped!)
 */
function shopDbFetchArray($query){
	return mysql_fetch_array($query);
}


function shopDbPrepareInput($string){
	return zen_db_prepare_input($string);
}


function shopDbInput($string){
	return zen_db_input($string);
}


/**
 * @param string $query (escaped!)
 */
function shopDbNumRows($query){
	return mysql_num_rows($query);
	
}


function shopDbOutput($string) {
	return zen_db_output($string);
}


function shopAdressFormat($address_format_id, $address, $html, $boln, $eoln){
	return zen_address_format($address_format_id, $address, $html, $boln, $eoln);
}


function shopDisplayTaxValue($value){
	return zen_display_tax_value($value);
}


/**
 * tax will ALWAYS be added (DISPLAY_PRICE_WITH_TAX[_ADMIN] will be ignored!)
 * @return double
 */
function shopAddTax($price, $tax){
	//Zen-Bugfix: function zen_add_tax() cannot be used, because it calculates only correct, if DISPLAY_PRICE_WITH_TAX[_ADMIN] is set to true
	$tax = $tax/100;
	return $price + ($price * $tax);
}


function shopDatetimeShort($raw_datetime){
	return zen_datetime_short($raw_datetime);
}


function shopImage($src,$alt){
	return zen_image($src,$alt);
}


function shopDrawForm($name, $action, $parameters){
	return zen_draw_form($name, $action, $parameters);
}


function shopGetAllGetParams($exclude_array){
	return zen_get_all_get_params($exclude_array);
}


function shopDrawTextAreaField($name, $wrap, $width, $height, $text){
	return zen_draw_textarea_field($name, $wrap, $width, $height, $text);
}


function shopDrawCheckboxField($name ,$value, $checked){
	return zen_draw_checkbox_field($name ,$value, $checked);
}


function shopDrawPulldownMenu($name, $values,$default){
	return zen_draw_pull_down_menu($name, $values,$default);
}


function shopDrawRadioField($name, $value, $checked, $parameters = ''){
	return zen_draw_radio_field($name,$value,$checked,$parameters);
}


function shopHrefLink($page, $parameters){
	return zen_href_link($page,$parameters);
}


function shopDbMail($to_name, $to_email_address, $email_subject, $message_body_plain, $from_email_name, $from_email_address, $block=array(), $module='default', $attachments_list=''){
	zen_mail($to_name, $to_email_address, $email_subject, $message_body_plain, $from_email_name, $from_email_address, $block=array(), $module='default', $attachments_list='' );
}


function shopCatalogHrefLink($page, $parameters){
	return zen_catalog_href_link($page, $parameters);
}


function shopDateLong($raw_date){
	return zen_date_long($raw_date);
}