<?php

/**
 * @version SOFORT Gateway - $Date: 2012-11-06 18:36:45 +0100 (Di, 06 Nov 2012) $
 * @author SOFORT AG (integration@sofort.com)
 * @link http://www.sofort.com/
 *
 * Copyright (c) 2012 SOFORT AG
 *
 * $Id: sofort_sofortueberweisung.php 5627 2012-11-06 17:36:45Z rotsch $
 */

include_once ((IS_ADMIN_FLAG === true ? DIR_FS_CATALOG_MODULES : DIR_WS_MODULES).'payment/sofort/sofort.php');

class sofort_su extends sofort {
	
	/**
	 * checked ok
	 */
	function sofort_su() {
		global $order;
		
		$this->code = 'sofort_su';
		
		parent::sofort();
		
		$this->_checkExistingSofortConstants('su');
		
		//zen-Bug: sometimes admin-title is called for public-view
		if ($_GET['main_page'] == FILENAME_CHECKOUT_CONFIRMATION || $_GET['main_page'] == FILENAME_CHECKOUT_PROCESS) {
			$this->title = MODULE_PAYMENT_SOFORT_SU_TEXT_TITLE;
		} else {
			$this->title = MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_TEXT_TITLE;
		}
		
		$this->title_extern = MODULE_PAYMENT_SOFORT_SU_TEXT_TITLE;
		$this->paymentMethod = 'SU';
		
		if (defined('MODULE_PAYMENT_SOFORT_SU_KS_STATUS') && MODULE_PAYMENT_SOFORT_SU_KS_STATUS == 'True') {
			$this->title_extern = MODULE_PAYMENT_SOFORT_SU_KS_TEXT_TITLE;
		}
		
		if(defined('MODULE_PAYMENT_SOFORT_SU_RECOMMENDED_PAYMENT') && MODULE_PAYMENT_SOFORT_SU_RECOMMENDED_PAYMENT == 'True') {
			$this->title_extern .= ' ' . MODULE_PAYMENT_SOFORT_SU_RECOMMENDED_PAYMENT_TEXT;
		}
		
		$this->enabled = ((defined('MODULE_PAYMENT_SOFORT_SU_STATUS') && MODULE_PAYMENT_SOFORT_SU_STATUS == 'True') ? true : false);
		
		$this->description = MODULE_PAYMENT_SOFORT_SU_TEXT_DESCRIPTION.'<br />'.MODULE_PAYMENT_SOFORT_MULTIPAY_VERSIONNUMBER.': '.HelperFunctions::getSofortmodulVersion();
		if ($this->_isInstalled() && (!defined('MODULE_PAYMENT_SOFORT_MULTIPAY_MODULE_VERSION') ||
				strcasecmp(trim(MODULE_PAYMENT_SOFORT_MULTIPAY_MODULE_VERSION), trim(HelperFunctions::getSofortmodulVersion())) != 0)) {
			$this->description = '<span style ="color:red; font-weight: bold; font-size: 1.2em">'.MODULE_PAYMENT_SOFORT_MULTIPAY_UPDATE_NOTICE.'</span><br /><br />'.$this->description;
		}
		$this->description .= MODULE_PAYMENT_SOFORT_SU_TEXT_DESCRIPTION_EXTRA;
		
		$this->sort_order = (defined('MODULE_PAYMENT_SOFORT_SU_SORT_ORDER') ? MODULE_PAYMENT_SOFORT_SU_SORT_ORDER : false);
		
		if (is_object($order)) {
			$this->update_status();
		}
		
		if (defined('MODULE_PAYMENT_SOFORT_SU_STATUS')) {
			$this->sofort = new SofortLib_Multipay(MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY);
			$this->sofort->setVersion(HelperFunctions::getSofortmodulVersion());
			
			if (defined('MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED') && MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED == "True") {
				$this->sofort->setLogEnabled();
			}
		}
	}
	
	
	/**
	 * checked ok
	 */
	function selection() {
		
		if (!parent::selection()) {
			$this->sofort->log("Notice: Paymentmethod ".$this->code." will be deactivated for selection.");
			$this->enabled = false;
			return false;
		}
		
		$title = '';
		
		switch (MODULE_PAYMENT_SOFORT_MULTIPAY_IMAGE) {
			case 'Logo & Text':
				if(MODULE_PAYMENT_SOFORT_SU_KS_STATUS == 'True') {
					$title = $this->_setImageText('logo_155x50.png', MODULE_PAYMENT_SOFORT_MULTIPAY_SU_CHECKOUT_TEXT_KS, '155', '50');
				} else {
					$title = $this->_setImageText('logo_155x50.png', MODULE_PAYMENT_SOFORT_MULTIPAY_SU_CHECKOUT_TEXT, '155', '50');
				}
				break;
			case 'Infographic':
				if(MODULE_PAYMENT_SOFORT_SU_KS_STATUS == 'True') {
					$title = $this->_setImageText('banner_400x100_ks.png', '', '400', '100');
				} else {
					$title = $this->_setImageText('banner_300x100.png', '', '300', '100');
				}
				break;
		}
		
		//add ks-link, if ks is active
		$title = str_replace('[[link_beginn]]', '<a href="'.MODULE_PAYMENT_SOFORT_MULTIPAY_SU_CHECKOUT_INFOLINK_KS.'" target="_blank" style="cursor: pointer; text-decoration: underline;">', $title);
		$title = str_replace('[[link_end]]', '</a>', $title);
		
		return array(
			'id'	 => $this->code,
			'module' => $this->title_extern,
			'fields' => array(
				array(
					'title' => $title,
					'field' => '',
				),
			),
		);
	}
	
	
	/**
	 * checked ok
	 */
	function _setImageText($image, $text, $width, $height) {
		$lng = HelperFunctions::getShortCode($_SESSION['language']);
		$image = 'https://images.sofort.com/'.$lng.'/su/'.$image;
		
		$image = '<img src="'.$image.'" alt="'.MODULE_PAYMENT_SOFORT_SU_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGEALT.'" width="'.$width.'" height="'.$height.'"/>';
		
		$title = MODULE_PAYMENT_SOFORT_SU_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGE;
		$title = str_replace('{{image}}', $image, $title);
		$title = str_replace('{{text}}', $text, $title);
		return $title;
	}
	
	
	/**
	 * checked ok
	 */
	function install() {
		global $db;
		
		//install shared keys and lang-files, that are used by all/most multipay-modules
		if (parent::install() === 'failed') {
			return 'failed';
		}
		
		$sofortStatuses = $this->_insertAndReturnSofortStatus();
		$confirmedStatus = 	(isset($sofortStatuses['translate_confirmed'])&& !empty($sofortStatuses['translate_confirmed']))? $sofortStatuses['translate_confirmed'] : '';
		$refundedStatus =	(isset($sofortStatuses['refunded'])&& !empty($sofortStatuses['refunded']))? $sofortStatuses['refunded'] : '';
		$checkStatus =		(isset($sofortStatuses['check'])&& !empty($sofortStatuses['check']))? $sofortStatuses['check'] : '';
		$unchangedStatus =	(isset($sofortStatuses['unchanged'])&& !empty($sofortStatuses['unchanged']))? $sofortStatuses['unchanged'] : '';
		
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_STATUS_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_STATUS', 'False','".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_STATUS_DESC)."', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_KS_STATUS_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_KS_STATUS', 'False','".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_KS_STATUS_DESC)."', '6', '30', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_COUNTRIES_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_COUNTRIES', '','".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_COUNTRIES_DESC)."', '6', '12', now())");
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_SORT_ORDER_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_SORT_ORDER', '0','".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_SORT_ORDER_DESC)."', '6', '16', now())");
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_RECOMMENDED_PAYMENT_TITLE)."' , 'MODULE_PAYMENT_SOFORT_SU_RECOMMENDED_PAYMENT', 'False','".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_RECOMMENDED_PAYMENT_DESC)."', '6', '5', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, use_function, set_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_ZONE_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_ZONE', '0','".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_ZONE_DESC)."', '6', '13', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
		
		//"Bestaetigt": pending-not_credited_yet
		//Important notice: constantname is also used for status: untraceable-sofort_bank_account_needed
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_PEN_NOT_CRE_YET_STATUS_ID_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_PEN_NOT_CRE_YET_STATUS_ID', '".HelperFunctions::escapeSql($confirmedStatus)."', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_PEN_NOT_CRE_YET_STATUS_ID_DESC)."', '6', '30', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Bestellung pruefen": loss-not_credited
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_LOS_NOT_CRE_STATUS_ID_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_LOS_NOT_CRE_STATUS_ID', '".HelperFunctions::escapeSql($checkStatus)."', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_LOS_NOT_CRE_STATUS_ID_DESC)."', '6', '30', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Geldeingang": received-credited
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_REC_CRE_STATUS_ID_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_REC_CRE_STATUS_ID', '".HelperFunctions::escapeSql($unchangedStatus)."', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_REC_CRE_STATUS_ID_DESC)."', '6', '30', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Teilrueckbuchung": refunded-compensation
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_REF_COM_STATUS_ID_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_REF_COM_STATUS_ID', '".HelperFunctions::escapeSql($unchangedStatus)."', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_REF_COM_STATUS_ID_DESC)."', '6', '30', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		//"Vollstaendige Rueckbuchung": refunded-refunded
		$db->Execute("INSERT INTO ".HelperFunctions::escapeSql(TABLE_CONFIGURATION)." (configuration_title, configuration_key, configuration_value, configuration_description,  configuration_group_id, sort_order, set_function, use_function, date_added)
			VALUES ('".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_REF_REF_STATUS_ID_TITLE)."'  , 'MODULE_PAYMENT_SOFORT_SU_REF_REF_STATUS_ID', '".HelperFunctions::escapeSql($refundedStatus)."', '".HelperFunctions::escapeSql(MODULE_PAYMENT_SOFORT_SU_REF_REF_STATUS_ID_DESC)."', '6', '30', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
	}
	
	
	/**
	 * checked ok
	 */
	function remove() {
		global $db;
		
		$db->Execute("DELETE FROM " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " WHERE configuration_key LIKE 'MODULE_PAYMENT_SOFORT_SU%'");
		$db->Execute("DELETE FROM " . HelperFunctions::escapeSql(TABLE_CONFIGURATION) . " WHERE configuration_key LIKE 'MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG%'");
		
		//if this is the last removing of a multipay-paymentmethod --> we also remove all shared keys, that are used by all/most multipay-modules
		parent::remove();
	}
	
	
	/**
	 * checked ok
	 */
	function keys() {
		
		parent::keys();
		
		return array(
			'MODULE_PAYMENT_SOFORT_SU_STATUS' ,
			'MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_AUTH',
			'MODULE_PAYMENT_SOFORT_SU_RECOMMENDED_PAYMENT',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_IMAGE' ,
			'MODULE_PAYMENT_SOFORT_MULTIPAY_REASON_1',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_TEXT_REASON_2' ,
			'MODULE_PAYMENT_SOFORT_SU_COUNTRIES' ,
			'MODULE_PAYMENT_SOFORT_SU_ZONE',
			'MODULE_PAYMENT_SOFORT_SU_SORT_ORDER',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_PROF_SETTINGS',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_TEMP_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_MULTIPAY_ABORTED_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_SU_PEN_NOT_CRE_YET_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_SU_LOS_NOT_CRE_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_SU_REC_CRE_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_SU_REF_COM_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_SU_REF_REF_STATUS_ID',
			'MODULE_PAYMENT_SOFORT_SU_KS_STATUS',
			//'MODULE_PAYMENT_SOFORT_MULTIPAY_LOG_ENABLED',
		);
	}
}
